using Microsoft.AspNetCore.Components.Web;
using Microsoft.AspNetCore.Components.WebAssembly.Hosting;
using Radzen;
using Razen2.Client;
using Microsoft.AspNetCore.Components.Authorization;

var builder = WebAssemblyHostBuilder.CreateDefault(args);
builder.Services.AddScoped<DialogService>();
builder.Services.AddScoped<NotificationService>();
builder.Services.AddScoped<TooltipService>();
builder.Services.AddScoped<ContextMenuService>();
builder.Services.AddTransient(sp => new HttpClient{BaseAddress = new Uri(builder.HostEnvironment.BaseAddress)});
builder.Services.AddScoped<Razen2.Client.Radzen2Service>();
builder.Services.AddAuthorizationCore();
builder.Services.AddHttpClient("Razen2.Server", client => client.BaseAddress = new Uri(builder.HostEnvironment.BaseAddress));
builder.Services.AddTransient(sp => sp.GetRequiredService<IHttpClientFactory>().CreateClient("Razen2.Server"));
builder.Services.AddScoped<Razen2.Client.SecurityService>();
builder.Services.AddScoped<AuthenticationStateProvider, Razen2.Client.ApplicationAuthenticationStateProvider>();
var host = builder.Build();
await host.RunAsync();