using System;
using System.Linq;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using System.Threading.Tasks;

using Razen2.Server.Data;

namespace Razen2.Server.Controllers
{
    public partial class ExportRadzen2Controller : ExportController
    {
        private readonly Radzen2Context context;
        private readonly Radzen2Service service;

        public ExportRadzen2Controller(Radzen2Context context, Radzen2Service service)
        {
            this.service = service;
            this.context = context;
        }

        [HttpGet("/export/Radzen2/projects/csv")]
        [HttpGet("/export/Radzen2/projects/csv(fileName='{fileName}')")]
        public async Task<FileStreamResult> ExportProjectsToCSV(string fileName = null)
        {
            return ToCSV(ApplyQuery(await service.GetProjects(), Request.Query), fileName);
        }

        [HttpGet("/export/Radzen2/projects/excel")]
        [HttpGet("/export/Radzen2/projects/excel(fileName='{fileName}')")]
        public async Task<FileStreamResult> ExportProjectsToExcel(string fileName = null)
        {
            return ToExcel(ApplyQuery(await service.GetProjects(), Request.Query), fileName);
        }
    }
}
